import python.zdf as zdf
import numpy as np
import sys

def get_files(version, example):
    x = []
    y = []
    z = []
    if example == "weibel":
        last_file = "000500"
    elif example == "lwfa":
        last_file = "001450"
    (x, sinfo) = zdf.read(version + "/em2d/test-" + example + "/EMF/B1-" + last_file + ".zdf")
    (y, sinfo) = zdf.read(version + "/em2d/test-" + example + "/EMF/B2-" + last_file + ".zdf")
    (z, sinfo) = zdf.read(version + "/em2d/test-" + example + "/EMF/B3-" + last_file + ".zdf")
    return (x, y, z)

def get_average_error(version, example):
    (x_s, y_s, z_s) = get_files("serial", example)
    (x_p, y_p, z_p) = get_files(version, example)
    x = np.sum((x_s - x_p)**2) / np.size(x_s)
    y = np.sum((y_s - y_p)**2) / np.size(y_s)
    z = np.sum((z_s - z_p)**2) / np.size(z_s)
    return (x + y + z) / 3

def checkSuccess(version, example):
    error = get_average_error(version, example)

    if example == "weibel" and error < 1e-09:
        return 1
    elif example == "lwfa" and error < 1e-11:
        return 1
    else:
        return 0

if __name__ == "__main__":
    print ("SUCCESS") if checkSuccess(sys.argv[1], sys.argv[2]) == 1 else print ("FAILED")
