#!/bin/bash

for TEST_FILE in "weibel" "lwfa"
do
    echo test version: $TEST_FILE
    for VERSION in "omp-atomic-1" "omp-reduction-1" "omp-atomic-2" "omp-reduction-2"
    do
        echo $VERSION
        cd $VERSION/em2d
    
        cd input
        cp $TEST_FILE.c simulation-test.c
        cd ..

        make -s clean all

	    rm -r test-$TEST_FILE
        mkdir test-$TEST_FILE
        cd test-$TEST_FILE

        FILENAME=$TEST_FILE-times
        OUTPUT=""
        for THREADS in 2 4 8 12 24
        do
	    echo threads: $THREADS
            OUTPUT+="\n$THREADS THREADS\n"
            for i in $(seq 1 10):
            do
	        echo iteration: $i
	        OUTPUT+=$(../zpic $THREADS 1>&1)
            done
        done

        echo -e $OUTPUT | grep -Eo "time.*$|.*THREADS" | grep -Eo "[0-9].*[0-9]|.*THREADS" > ../../$FILENAME.txt

	rm -r EMF
    	mkdir EMF
    	cp -r /tmp/EMF EMF/
        cd ..
        
	make -s clean
        rm -f input/simulation-test.c
        cd ../../
    done
done
