#!/bin/bash

versions=(serial omp-atomic-1 omp-atomic-2 omp-reduction-1 omp-reduction-2)
examples=(weibel lwfa)

successes=0

for version in ${versions[*]}
do
    echo VERSION: $version
    for example in ${examples[*]}
    do
        echo RUNNING VERSION $version WITH EXAMPLE $example
        cd $version/em2d

        cp input/$example.c input/simulation-test.c

        make clean all

	rm -rf /tmp/EMF

        ./zpic &> /tmp/ignore.txt

	rm -rf test-$example
	echo STORING REPORT FILES
    	mkdir test-$example
    	mv /tmp/EMF test-$example/

	make -s clean
        rm -f input/simulation-test.c
	cd ../../

	if [ "$version" != "serial" ]; then
	    echo CHECK LAST REPORT
	    result=$(python3 checkLastReport.py $version $example)
	    echo $result
	    if [ "$result" = "SUCCESS" ]; then
	        successes=$(expr $successes + 1)
	    fi
	fi
    done
done

echo ALL DONE
echo SUCCESS RATE: $successes / $(expr $(($((${#versions[*]} - 1)) * ${#examples[*]})))
